# -*- coding:Utf-8 -*-
# ./addons/eventscripts/_libs/python/hudlib/hudqueue.py

import es, psyco, gamethread
psyco.full()



class HudQueue(list):
    """
        HudQueue list
            - list with elements automatically added at first position
    """

    def add(self, hudbox):
        # if hudbox is a quicksend
        if hudbox.quicksend:
            # for all box queued
            for box in self[:]:
                # if an other quicksend exists
                if box.quicksend:

                    # cancel appropriated thread
                    if box.type == "hinttext":
                        gamethread.cancelDelayed(box.hinttextthread)
                    elif box.type == "keyhinttext":
                        gamethread.cancelDelayed(box.keyhinttextthread)
                    # then remove it from queue and break loop
                    self.remove(box)
                    break

        # insert new hudbox at first place
        if not hudbox in self: self.insert(0, hudbox)
        # or append once more. the timeout will remove the first
        elif hudbox.timeoutfire:
            if self.count(hudbox) < 2: self.append(hudbox)
        # or move it at first place
        else: self.insert(0, self.pop(self.index(hudbox)))

    def first(self):
        # try to return first hudbox
        return self[0] if self else None
