# -*- coding:Utf-8 -*-
# ./addons/eventscripts/_libs/python/hudlib/lines.py

import psyco
psyco.full()



class Lines(object):
    """ Lines object """

    def __init__(self):
        self.lines = []
        self.string = ""

    def addline(self, text, opts = {}, update = False):
        # add a line in list
        if not self._language: self.lines.append(str(text))
        else: self.lines.append((str(text), opts))
        if update: self.update()

    def insline(self, index, text, opts = {}, update = False):
        # insert a line in list
        if not self._language: self.lines.insert(index, str(text))
        else: self.lines.insert(index, (str(text), opts))
        if update: self.update()

    def modline(self, index, text, opts = {}, update = False):
        # modifie a line from list
        if not self._language: self.lines[int(index)] = str(text)
        else: self.lines[int(index)] = (str(text), opts)
        if update: self.update()

    def delline(self, value, update = False):
        # delete a line from list
        if str(value).isdigit():
            del self.lines[int(value)]
        elif not self._language:
            self.lines.remove(value)
        else:
            del self.lines[self.index(value)]
        if update: self.update()

    def __iter__(self):
        # iter self.lines
        return iter(self.lines)


    """ simulate list commands """
    def __sub__(self, value):
        if isinstance(value, tuple): self.delline(*value)
        else: self.delline(value)

    def __add__(self, value):
        if isinstance(value, str): self.addline(value)
        else: self.addline(*value)

    def __setitem__(self, index, value):
        if isinstance(value, str): self.modline(index, value)
        else: self.modline(index, *value)

    def insert(self, index, value):
        if isinstance(value, str): self.insline(index, value)
        else: self.insline(index, *value)

    def count(self, value):
        if not self._language:
            return self.lines.count(value)
        count = 0
        for line in self:
            if line[0] == value: count += 1
        return count

    def index(self, value):
        if not self._language:
            return self.lines.index(value)
        for line in self:
            if line[0] == value:
                return self.lines.index(line)

    def __getitem__(self, index):
        return self.lines[index]

    def __len__(self):
        return len(self.lines)
