# coding:Utf-8
import es, hudlib, playerlib


playerHud = {}


def player_spawn(event_var):
    if int(event_var["es_userteam"]) > 1:
        userid = event_var["userid"]
        # create and store HintText box
        hudbox = playerHud[userid] = hudlib.hinttextbox()

        # define time max hud can be displayed
        hudbox.timeout = 4
        # define function to execute when hud of player times out
        hudbox.usertimeout = userhud_timeout
        # load language file
        hudbox.language("../addons/eventscripts/hud/examples/esp/xlang_hudhp/lang.ini")

        # add line for first time
        hudbox.addline("health_point")
        # update and send hud
        userhud_update(userid, hudbox)


def player_hurt(event_var):
    userid = event_var["userid"]
    # update and send hud
    userhud_update(userid, playerHud[userid])

def userhud_timeout(userid, reason, hudbox):
    if reason == "timeout":
        # update and send hud
        userhud_update(userid, hudbox)

def userhud_update(userid, hudbox):
    # get health of player
    health = playerlib.getPlayer(userid).health
    # modifie the first line (index starts at 0)
    hudbox.modline(0, "health_point", {"healthpoint" : health})
    # send hud to player
    hudbox.send(userid)


def player_death(event_var):
    # delete hud of player
    userhud_delete(event_var["userid"])

def player_disconnect(event_var):
    # delete hud of player
    userhud_delete(event_var["userid"])

def userhud_delete(userid):
    if playerHud.has_key(userid):
        # delete hud (kill threads, etc...)
        playerHud[userid].kill()
        del playerHud[userid]

def unload():
    # delete all hud (kill threads, etc...)
    for hudbox in playerHud.values():
        hudbox.kill()
        
